#include "Stage.h"
#include "Stages.h"
#include "Main.h"
#include "Vram.h"
#include "Sprite.h"
#include "Chars.h"
#include "CopyMemory.h"
#include "Status.h"
#include "Movable.h"
#include "Man.h"
#include "Block.h"
#include "Monster.h"
#include "Point.h"

extern void _deb();

constexpr byte MapSize = MapWidth / 4 * MapHeight;

ptr<Stage> pStage;
byte[MapSize] CellMap;

static const byte[] CellChars = {
    0, 0,
    Char_Block, Color_Block,
    Char_Wall, Color_Wall,
};


void InitStage() 
{
    {
        ptr<Stage> p;
        byte i, j;
        p = Stages;
        i = 0;
        j = 0;
        while (i < CurrentStage) {
            ++p;
            ++i;
            ++j;
            if (j >= StageCount) {
                p = Stages;
                j = 0;
            }
        }
        pStage = p;
    }
    InitMonsters();
}


void InitTrying()
{
    CopyMemory(CellMap, pStage->bytes, MapSize);
    {
        byte i;
        StageTime = 60;
        i = pStage->enemyCount;
        do {
            StageTime += 30;
            --i;
        } while (i != 0);
    }
    HideAllSprites();
    // UpdateSprites();
    ClearScreen();
    PrintStatus();
    {
        ptr<byte> pBytes;
        byte y;
        pBytes = CellMap;
        y = 0;
        repeat (MapHeight) {
            byte x;
            x = 0;
            repeat (MapWidth / 4) {
                byte sourceByte;
                sourceByte = *pBytes;
                repeat (4) {
                    ptr<byte> p;
                    byte b, c, color;
                    b = sourceByte & Cell_Mask;
                    p = CellChars + (b << 1);
                    c = *p; ++p;
                    color = *p;
                    PutSprite(x, y, c, color);
                    ++x;
                    sourceByte >>= 2;
                }
                ++pBytes;
            }
            ++y;
        }
    }
    // DrawFence();
    InitMan();
    InitBlocks();
    StartMonsters();
    InitPoints();
    // UpdateSprites();
}


static ptr<byte> CellMapPtr(byte x, byte y)
{
    return CellMap + (((y << 1) + y) + (x >> 2));
}

byte GetCell(byte x, byte y)
{
    byte xMod, b;
    if (x >= MapWidth || y >= MapHeight) return Cell_Wall;
    b = *CellMapPtr(x, y);
    xMod = x & 3;
    if (xMod != 0) {
        do {
            b >>= 2;
            --xMod;
        } while (xMod != 0);
    }
    return b & Cell_Mask;
}


void SetCell(byte x, byte y, byte b)
{
    {
        ptr<byte> p;
        byte c, color;
        p = CellChars + (b << 1);
        c = *p; ++p;
        color = *p;
        PutSprite(x, y, c, color);
    }
    {
        ptr<byte> pMap;
        byte xMod, mask;
        pMap = CellMapPtr(x, y);
        mask = 0xfc;
        xMod = x & 3;
        if (xMod != 0) {
            do {
                b <<= 2;
                mask = (mask << 2) | 3;
                --xMod;
            } while (xMod != 0);
        }
        *pMap = (*pMap & mask) | b;
    }
}
