#include "Status.h"
#include "Vram.h"
#include "Main.h"
#include "Sprite.h"
#include "Print.h"
#include "Chars.h"
#include "Stage.h"

constexpr byte Char_Remain = Char_Man;

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        *pVram = c; ++pVram;
        ++p;
    }
    return pVram;
}

void PrintStatus() 
{
    PrintS(VramLeftTop + 0 * VramStep, "SC");
    PrintS(VramLeftTop + 9 * VramStep, "ST");
    PrintByteNumber2(VramLeftTop + 11 * VramStep, CurrentStage + 1);
    PrintS(VramLeftTop + 14 * VramStep, "T");

    {
        byte sprite;
        sprite = Sprite_Remain;
        if (RemainCount > 1) {
            byte x, i;
            x = 20 * 8;
            i = RemainCount - 1;
            // if (i > 2) {
            //     ShowSpriteXY(sprite, x, 0, Char_Remain, Color_Man);
            //     ++sprite;
            //     VramLeftTop[22] = i + ('0' - 1);
            // }
            // else {
                do {
                    ShowSpriteXY(sprite, x, 0, Char_Remain, Color_Man);
                    ++sprite;
                    x += 16;
                    --i;
                } while (i > 0);
            // }
        }
        while (sprite < Sprite_Remain_End) {
            HideSprite(sprite);
            ++sprite;
        }
    }
    PrintScore();
    PrintTime();
}

void PrintScore()
{
    ptr<byte> pVram;
    pVram = PrintNumber5(VramLeftTop + 2 * VramStep, Score);
    *pVram = '0';
}

void PrintTime()
{
    PrintByteNumber3(VramLeftTop + 15 * VramStep, StageTime);
}

static void EraseWindow()
{
    byte x;
    x = 3;
    repeat (6) {
        PutSprite(x, 3, 0, 0);
        ++x;
    }
}

void PrintGameOver()
{
    EraseWindow();
    PrintS(VramLeftTop + VramRowSize * 6 + 7 * VramStep, "GAME OVER");
}

void PrintTimeUp() 
{
    EraseWindow();
    PrintS(VramLeftTop + VramRowSize * 6 + 8 * VramStep, "TIME UP");
}

void Title()
{
    ClearScreen(); 
    HideAllSprites();
    PrintStatus();
    {
        constexpr byte LogoLength = 9;
        byte x, c, i;
        x = (192 - LogoLength * 16) / 2;
        c = Char_Logo;
        i = Sprite_Background;
        repeat (LogoLength) {
            ShowSpriteXY(i, x, 32, c, 6);
            ++i;
            ++c;
            x += 16;
        }
        PrintS(VramLeftTop + VramRowSize * 4 + (8 + LogoLength) * VramStep, "MINI");
    }
    PrintS(VramLeftTop + VramRowSize * 9 + 2 * VramStep, "PUSH TRIGGER BUTTON");
    PrintS(VramLeftTop + VramRowSize * 11 + 11 * VramStep, "INUFUTO 2023");
}